/**
 * Back 2 Browser Bytecode Translator
 * Copyright (C) 2012-2015 Jaroslav Tulach <jaroslav.tulach@apidesign.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. Look for COPYING file in the top folder.
 * If not, see http://opensource.org/licenses/GPL-2.0.
 */
package org.apidesign.vm4brwsr;

import org.testng.annotations.AfterClass;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

public class LibUseTest {
    private static TestVM code;

    @BeforeClass
    public static void initVM() throws Exception {
        code = TestVM.compileClass("org/apidesign/vm4brwsr/LibUse");
    }
    @AfterClass
    public static void releaseTheCode() {
        code = null;
    }

    @Test
    public void fourtyTwo() throws Exception {
        code.assertExec("Fourty two", LibUse.class, "fourtyTwo__I", 42);
    }

    @Test
    public void readAHiProperty() throws Exception {
        code.assertExec(
            "Object has property x", LibUse.class,
            "hiProperty__Ljava_lang_String_2Ljava_lang_String_2",
            "Hi", (Object)null
        );
    }

    @Test
    public void writeAHiProperty() throws Exception {
        code.assertExec(
            "Object has property x", LibUse.class,
            "hiProperty__Ljava_lang_String_2Ljava_lang_String_2",
            "Ahoj", "Ahoj"
        );
    }
}
